#if !defined(AFX_ENGINE_H__3F4CEE2A_37AE_4003_9A9A_2BF5D8B4F3CE__INCLUDED_)
#define AFX_ENGINE_H__3F4CEE2A_37AE_4003_9A9A_2BF5D8B4F3CE__INCLUDED_

#pragma once
#include<vector>
#include<math.h>

//!  ()
struct CObj{
	COLORREF color;		//!< 
	int r;				//!<  
	double m;			//!<  
	double x,y;			//!<  
	double dx,dy;		//!<  
	bool isStand();		//!<   
	CObj(COLORREF,int x0,int y0,int r0=10,double dx0=0,double dy0=0);
};


//! 
class CEngine  
{
	CRect m_bar;						//!< 
	CRect rect;							//!<  
	std::vector<CObj>m_list;			//!<   
	void CheckBorder(CObj*);			//!<     
	void CheckCollision(int n,CObj*);	//!<    
	void CheckBar(CObj*);				//!<     
	void CheckPoint(CPoint&,CObj*);		//!<     
	double Distance2(CPoint &point,CObj *obj);	//!<      
public:
	void Init(CRect &rect);			//!<  
	void Work();					//!<   
	const int GetCount();			//!<     
	const CObj *GetObj(int index);	//!<   
	const CRect &GetBar();			//!<   
};

#endif // !defined(AFX_ENGINE_H__3F4CEE2A_37AE_4003_9A9A_2BF5D8B4F3CE__INCLUDED_)
